SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[AccountSubAccountVCCBulkUpdateBatchDetail]
AS
BEGIN
	-- INSERT INTO [dbo].[TMP_TABLE_UPDATE] ([PlatformHash], [InstallationId], [AccountId], [SubAccountId], [VCC], [BatchTypeName], [BatchTypeId], [SystemService], [ProcessId], [EntityId], [FieldToUpdate], [ValueToUpdate])
	-- SELECT [PlatformHash], [InstallationId], [AccountId], [SubAccountId], [VCC], [BatchTypeName], [BatchTypeId], [SystemService], [ProcessId], [EntityId], [FieldToUpdate], [ValueToUpdate] FROM #AccountSubAccountVCCBulkUpdateBatchDetailTemp;
	-- SELECT * FROM [dbo].[TMP_TABLE_UPDATE] 
	
	-- ESTE PROCEDURE TIENE LA FUNCION DE ACTUALIZAR UN BLOQUE DE DATA EXISTENTE EN LA TABLA DETALLE DE TRANSACCION
	-- A PARTIR DE UNA TABLA TEMPORAL
	
	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS TIPOS DE UPDATE
	DECLARE MY_CURSOR CURSOR 
	LOCAL STATIC READ_ONLY FORWARD_ONLY
		FOR 
		SELECT DISTINCT ASAVDTTMP.[FieldToUpdate]
			-- FROM TMP_TABLE_UPDATE ASAVDTTMP 
			FROM #AccountSubAccountVCCBulkUpdateBatchDetailTemp ASAVDTTMP (NOLOCK)

	-- DECLARARAMOS UNA VARIABLE PARA INDICAR EL CAMPO ACTUAL QUE ESTAMOS ACTUALIZANDO
	DECLARE @CURRENT_FIELD_TO_UPDATE VARCHAR(50) = ''

	-- ABRIMOS Y RECORREMOS EL ARRAY DE CAMPOS A ACTUALIZAR
	OPEN MY_CURSOR
	FETCH NEXT FROM MY_CURSOR INTO @CURRENT_FIELD_TO_UPDATE
	WHILE @@FETCH_STATUS = 0
	BEGIN 
		--declare @CURRENT_FIELD_TO_UPDATE varchar(50) = 'TotalValidRequest';
		WITH 
		-- DECLARAMOS UNA CTE PARA DEPOSITAR LOS RESULTADOS DEL RESUMEN DE ACTUALIZACION
		CteTransactionDetailUpdate AS (
			SELECT ASAVDTTMP.[InstallationId]
					,ASAVDTTMP.[VCC]
					,ASAVDTTMP.[BatchTypeName]
					,ASAVDTTMP.[BatchTypeId]
					,ASAVDTTMP.[SystemService]
					,ASAVDTTMP.[EntityId] 
					,ASAVDTTMP.[FieldToUpdate]
					,CASE 
						WHEN ASAVDTTMP.[FieldToUpdate] = 'TotalValidRequest' THEN CAST(COUNT(ASAVDTTMP.[ValueToUpdate]) AS VARCHAR(10)) 
						WHEN ASAVDTTMP.[FieldToUpdate] = 'TotalInvalidRequest' THEN CAST(COUNT(ASAVDTTMP.[ValueToUpdate]) AS VARCHAR(10)) 
						ELSE ASAVDTTMP.[ValueToUpdate] END 'ValueToUpdate'
			-- FROM TMP_TABLE_UPDATE ASAVDTTMP (NOLOCK)
			FROM #AccountSubAccountVCCBulkUpdateBatchDetailTemp ASAVDTTMP (NOLOCK)
			WHERE ASAVDTTMP.[FieldToUpdate] = @CURRENT_FIELD_TO_UPDATE
			GROUP BY ASAVDTTMP.[InstallationId]
				,ASAVDTTMP.[VCC]
				,ASAVDTTMP.[BatchTypeName]
				,ASAVDTTMP.[BatchTypeId]
				,ASAVDTTMP.[SystemService]
				,ASAVDTTMP.[EntityId] 
				,ASAVDTTMP.[FieldToUpdate]
				,ASAVDTTMP.[ValueToUpdate] 
		)
		-- SELECT * FROM CteTransactionDetailUpdate
		
		-- HACEMOS EL UPDATE DE LA TABLA TRANSACTION DETAILED CRUZANDO CON LA CTE DE LA TEMPORAL UPDATE
		UPDATE ASAVDT
		SET --ASAVDT.[AccountId] = CASE WHEN ASAVDTTMP.[FieldToUpdate] = 'AccountId' THEN ASAVDTTMP.[ValueToUpdate] ELSE ASAVDT.[AccountId] END,
			ASAVDT.[ApiId] = CASE 
				WHEN ASAVDTTMP.[FieldToUpdate] = 'SpeechmaticsApi' THEN CONCAT('Speechmatics: ', ASAVDTTMP.[ValueToUpdate]) 
				--WHEN ASAVDTTMP.[FieldToUpdate] = 'IdathaApi' THEN CONCAT(ISNULL(ASAVDT.[ApiId], ''), ', Idatha: ', ASAVDTTMP.[ValueToUpdate]) 
				WHEN ASAVDTTMP.[FieldToUpdate] = 'IdathaApi' 
					THEN CASE 
							WHEN ASAVDT.[ApiId] IS NULL 
								THEN CONCAT('Idatha: ', ASAVDTTMP.[ValueToUpdate]) 
							ELSE CONCAT(ASAVDT.[ApiId], ', Idatha: ', ASAVDTTMP.[ValueToUpdate]) END 
				WHEN ASAVDTTMP.[FieldToUpdate] = 'LuisApi' THEN CONCAT('LUIS: ', ASAVDTTMP.[ValueToUpdate]) 
				WHEN ASAVDTTMP.[FieldToUpdate] = 'RasaApi' THEN CONCAT('RASA: ', ASAVDTTMP.[ValueToUpdate]) 
				WHEN ASAVDTTMP.[FieldToUpdate] = 'ApiId' THEN CONCAT('Cognitive: ', ASAVDTTMP.[ValueToUpdate]) 
				ELSE ASAVDT.[ApiId] END,
			ASAVDT.[IsDemo] = CASE WHEN ASAVDTTMP.[FieldToUpdate] = 'IsDemo' THEN ASAVDTTMP.[ValueToUpdate] ELSE ASAVDT.[IsDemo] END,
			-- ASAVDT.[ValidDurationTime] = CASE WHEN ASAVDTTMP.[FieldToUpdate] = 'ValidDurationTime' THEN ASAVDTTMP.[ValueToUpdate] ELSE ASAVDT.[ValidDurationTime] END,
			ASAVDT.[ValidDurationTime] = 
				CASE WHEN ASAVDTTMP.[FieldToUpdate] = 'ValidDurationTime' 
				THEN CASE
					WHEN ASAVDTTMP.[ValueToUpdate] <> 'null' THEN ASAVDTTMP.[ValueToUpdate] ELSE 0 END
				ELSE ASAVDT.[ValidDurationTime] END,
			ASAVDT.[TotalRequest] = CASE 
				WHEN (ASAVDTTMP.[SystemService] = 'COGNITIVE_ANALYSIS' AND ASAVDTTMP.[FieldToUpdate] = 'TotalValidRequest') THEN ASAVDT.[TotalRequest] + ASAVDTTMP.[ValueToUpdate] 
				WHEN (ASAVDTTMP.[SystemService] = 'SEMANTIC_ANALYSIS' AND ASAVDTTMP.[FieldToUpdate] = 'TotalPages') THEN ASAVDTTMP.[ValueToUpdate] 
				ELSE ASAVDT.[TotalRequest] END,
			ASAVDT.[TotalValidRequest] = CASE WHEN ASAVDTTMP.[FieldToUpdate] = 'TotalValidRequest' THEN ASAVDT.[TotalValidRequest] + ASAVDTTMP.[ValueToUpdate] ELSE ASAVDT.[TotalValidRequest] END,
			ASAVDT.[TotalInvalidRequest] = CASE WHEN ASAVDTTMP.[FieldToUpdate] = 'TotalInvalidRequest' THEN ASAVDT.[TotalInvalidRequest] + ASAVDTTMP.[ValueToUpdate] ELSE ASAVDT.[TotalInvalidRequest] END,
			ASAVDT.[TotalItems] = CASE WHEN ASAVDTTMP.[FieldToUpdate] = 'TotalResults' THEN ASAVDTTMP.[ValueToUpdate] ELSE ASAVDT.[TotalItems] END,
			ASAVDT.[TotalPages] = CASE WHEN ASAVDTTMP.[FieldToUpdate] = 'TotalPages' THEN ASAVDTTMP.[ValueToUpdate] ELSE ASAVDT.[TotalPages] END,
			ASAVDT.[ItemsPerPage] = CASE WHEN ASAVDTTMP.[FieldToUpdate] = 'TotalItemsPerPage' THEN ASAVDTTMP.[ValueToUpdate] ELSE ASAVDT.[ItemsPerPage] END,
			ASAVDT.[TotalPhrases] = CASE WHEN ASAVDTTMP.[FieldToUpdate] = 'TotalPhrases' THEN ASAVDTTMP.[ValueToUpdate] ELSE ASAVDT.[TotalPhrases] END,
			ASAVDT.[CharsPerPhrase] = CASE WHEN ASAVDTTMP.[FieldToUpdate] = 'CharsPerPhrase' THEN ASAVDTTMP.[ValueToUpdate] ELSE ASAVDT.[CharsPerPhrase] END,
			ASAVDT.[LastModifiedDate] = GETUTCDATE()
		FROM [dbo].[AccountSubAccountVCCDetailedTransaction] ASAVDT 
		INNER JOIN CteTransactionDetailUpdate ASAVDTTMP
			ON ASAVDTTMP.[InstallationId] = ASAVDT.[InstallationId]
				AND ASAVDTTMP.[VCC] = ASAVDT.[VCC]
				AND ASAVDTTMP.[BatchTypeName] = ASAVDT.[BatchTypeName]
				AND ASAVDTTMP.[BatchTypeId] = ASAVDT.[BatchTypeId]
				AND ASAVDTTMP.[SystemService] = ASAVDT.[SystemService]
				AND ASAVDTTMP.[EntityId] = ASAVDT.[EntityId]
		WHERE ASAVDTTMP.[InstallationId] IS NOT NULL
			AND ASAVDTTMP.[FieldToUpdate] = @CURRENT_FIELD_TO_UPDATE
			--AND ASAVDT.[IsFinished] <> 1

		FETCH NEXT FROM MY_CURSOR INTO @CURRENT_FIELD_TO_UPDATE
	END
	CLOSE MY_CURSOR
	DEALLOCATE MY_CURSOR

	-- TERMINADO EL PROCESO ELIMINAMOS LA TABLA TEMPORAL*/
	DROP TABLE #AccountSubAccountVCCBulkUpdateBatchDetailTemp
	
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
