SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetAccount]
(
	@PlatformHash VARCHAR(100) = NULL,
	@InstallationId VARCHAR(50) = NULL,
	@Id VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- VERIFICAMOS SI EXISTE UNA PLATAFORMA CON EL PLATFORMHASH INGRESADO
	IF NOT EXISTS(
		SELECT P.[PlatformHash] 
			FROM dbo.[Platform] P 
			WHERE P.[PlatformHash] = @PlatformHash
				AND P.[InstallationId] = @InstallationId
	)
	BEGIN
		-- SI NO EXISTE LA PLATAFORMA ENVIAMOS UN MENSAJE DE ERROR
		RAISERROR('DATABASE_ERROR_NOT_FOUND_PLATAFORM', 16, 16)
	END

	-- HACEMOS LA BUSQUEDA DE LA CUENTA POR MEDIO DE LA ID
	SELECT A.[AccountId]											'accountId',
			A.[SubAccountId]										'subAccountId',
			A.[CountryCode]										'countryCode',
			A.[CurrencyCode]										'currencyCode',
			A.[TranscriptionRatePerHour]							'transcriptionRatePerHour',
			A.[TranscriptionRatePerSecond]							'transcriptionRatePerSecond',
			A.[SemanticAnalysisRatePerTransaction]					'semanticAnalysisRatePerTransaction',
			A.[CognitiveAnalysisRatePerTransaction]					'cognitiveAnalysisRatePerTransaction',
			A.[User]												'user',
			A.[Token]												'token'
		FROM dbo.[Account] A (NOLOCK)
		WHERE A.[PlatformHash] = @PlatformHash
			AND A.[InstallationId] = @InstallationId
			AND A.[ID] = @Id

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
