SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetAccountSubAccountVCCBatchSummaryId](
	@PlatformHash VARCHAR(50) = NULL,
	@InstallationId VARCHAR(50) = NULL,
	@VCC VARCHAR(50) = NULL,
	@BatchTypeName VARCHAR(50) = NULL,
	@BatchTypeId VARCHAR(50) = NULL
)
AS
BEGIN
	-- ESTE SP TIENE LA FINALIDAD DE ACTUALIZAR LOS SALDOS DE LAS CARTERAS DEL VCC
	SET NOCOUNT ON

	-- VERIFICAMOS QUE TENEMOS LOS PARAMETROS NECESARIOS
	IF @BatchTypeName IS NULL OR @BatchTypeId IS NULL
		-- LANZAMOS MENSAJE AVISANDO QUE FALTA ACCOUNTID
		RAISERROR('DATABABASE_ERROR_MISSING_PARAMETERS', 16, 16)

	-- RETORNAMOS EL BATCHID UNICO
	SELECT DISTINCT ASAVST.[BatchId] 'batchId'
	FROM [dbo].[AccountSubAccountVCCSummaryTransaction] ASAVST (NOLOCK)
	WHERE ASAVST.[InstallationId] = @InstallationId
		AND ASAVST.[VCC] = @VCC
		AND ASAVST.[BatchTypeName] = @BatchTypeName 
		AND ASAVST.[BatchTypeId] = @BatchTypeId

	SET NOCOUNT OFF
END 
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
