SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetAccountSubAccountVCCRetainedBalance] (
	@InstallationId VARCHAR(100) = NULL,
	@AccountId VARCHAR(50) = NULL,
	@SubAccountId VARCHAR(50) = NULL,
	@VCC VARCHAR(50) = NULL
) AS
BEGIN
	SET XACT_ABORT, NOCOUNT ON

	-- ESTE SP TIENE POR FINALIDAD RETORNAR UN LISTADO DE VCCS CON SALDO RETENIDO PERTENECIENTES A UNA CUENTA
	SELECT ASAVST.[VCC]													'vcc'
		FROM [dbo].[AccountSubAccountVCCSummaryTransaction] ASAVST (NOLOCK)
		INNER JOIN [dbo].[AccountVCCBalance] AVB (NOLOCK)
			ON AVB.[InstallationId] = ASAVST.[InstallationId]
				AND AVB.[VCC] = ASAVST.[VCC]
		WHERE ASAVST.[InstallationId] = '4289C47D-A8D0-41BB-A113-3D2175D3A586' --@InstallationId
			AND (
				ASAVST.[Status] = 'CREATED'
				OR
				ASAVST.[Status] = 'RUNNING'
			)
			AND AVB.[RetainedBalance] > 0
			AND AVB.[AccountId] = @AccountId
			-- AND [AccountVCCBalance].[VCC] = 'occ_test'
		GROUP BY ASAVST.[VCC]

	SET XACT_ABORT, NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
