SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetAllegroBillingInteractions] (
   	@VCC VARCHAR(50) = NULL,
	@IP Varchar(50), 
	@Type Int,
	@SecondsPerRequest Int,
   	@StartDate DATETIME = '1980-01-01',
    @EndDate DATETIME = '2050-01-01',
	@Campaigns VARCHAR(MAX) = '',
 	@Agents VARCHAR(MAX) = '',
   	@Origins VARCHAR(100) = NULL,
	@StartHour VARCHAR(50) = NULL,
	@EndHour VARCHAR(50) = NULL,
	@MinDuration INT = 0,
    @MaxDuration INT = 100000,
    @Results VARCHAR(MAX) = NULL,
	@Formats VARCHAR(50) = NULL
)
AS 
BEGIN 
	-- SETTEAMOS VALORES MINIMOS PARA LAS HORAS DE INICIO Y FIN
	IF (@StartHour IS NOT NULL AND @StartHour = '') SET @StartHour = '00:00:00';
	IF (@EndHour IS NOT NULL AND @EndHour = '') SET @EndHour = '23:59:59';

	-- DECLARAMOASUN CADENA PARA EL QUERY FINAL
	DECLARE @SQL_SELECT_0 VARCHAR(MAX) = '';
	DECLARE @SQL_SELECT_1 VARCHAR(MAX) = '';
	DECLARE @SQL_FROM VARCHAR(MAX) = '';
	DECLARE @SQL_FILTER VARCHAR(MAX) = '';
	DECLARE @SQL_EXTRA VARCHAR(MAX) = '';
	
	-- DECLARAMOS VARIABLES PARA NOS NOMBRES DE LAS TABLAS
	DECLARE @INTERACTION_DETAIL_TABLE NVARCHAR(100)
	DECLARE @INTERACTION_ACTOR_DETAIL_TABLE NVARCHAR(100)
	DECLARE @INTERACTION_MULTIMEDIA_PARTS_TABLE NVARCHAR(100)
	DECLARE @CAMPAIGN_GOAL_RESULT_MANAGEMENT_TABLE NVARCHAR(100)


	IF @MinDuration = @MaxDuration AND @MaxDuration = 0
	BEGIN
		SET @MaxDuration = 100000;
	END

	-- EL PARAMETRO TYPE DEFINE SI LA BD ALLEGRO SE ENCUENTRA LOCAL O REMOTO
	IF (@Type = 0)  
	BEGIN  
		SET @INTERACTION_DETAIL_TABLE = '[' + @Ip + ']' + '.HistoricalData.dbo.[InteractionDetail]'
		SET @INTERACTION_ACTOR_DETAIL_TABLE = '[' + @Ip + ']' + '.HistoricalData.dbo.[InteractionActorDetail]'
		SET @INTERACTION_MULTIMEDIA_PARTS_TABLE = '[' + @Ip + ']' + '.HistoricalData.dbo.[InteractionMultimediaParts]'
		SET @CAMPAIGN_GOAL_RESULT_MANAGEMENT_TABLE = '[' + @Ip + ']' + '.mmprodat.dbo.[CampaignGoalResultManagement]'
	END
	ELSE IF(@Type = 1) 
	BEGIN
		SET @INTERACTION_DETAIL_TABLE = 'HistoricalData.dbo.[InteractionDetail]';
		SET @INTERACTION_ACTOR_DETAIL_TABLE = 'HistoricalData.dbo.[InteractionActorDetail]'
		SET @INTERACTION_MULTIMEDIA_PARTS_TABLE = 'HistoricalData.dbo.[InteractionMultimediaParts]';
		SET @CAMPAIGN_GOAL_RESULT_MANAGEMENT_TABLE = 'mmprodat.dbo.[CampaignGoalResultManagement]';
	END  

	-- ARMAMOS EL QUERY PARA HACER LA CONSULTA
	SET @SQL_SELECT_1 += '
		SELECT '

	SET @SQL_SELECT_1 += '
				ID.[Id],
				IMP.[Section],
				IMP.[Part],
				ID.[DurationTime],
				ID.[AttentionTime],
				A.[IsProcess],
				A.[IsTranscribed] '
				
	-- ARMAMOS LA PARTE DE TABLAS 
	SET @SQL_FROM += '
			FROM ' + @INTERACTION_MULTIMEDIA_PARTS_TABLE + ' IMP (NOLOCK)
			LEFT JOIN ' + @INTERACTION_DETAIL_TABLE + ' ID (NOLOCK) 
				ON ID.[Id] = IMP.[Id]
			LEFT JOIN ' + @INTERACTION_ACTOR_DETAIL_TABLE + ' IAD (NOLOCK) 
				ON IAD.[Id] = ID.[id]
			LEFT JOIN [dbo].[Audio] A (NOLOCK) 
				ON A.[ID] = ID.[Id]
					AND A.[Section] = IMP.[Section]
					AND A.[Part] = IMP.[Part] '
					
	-- ARMAMOS LA PARTE DE FILTROS
	SET @SQL_FILTER += '
			WHERE ID.[VirtualCC] = ''' + @VCC + '''
				AND ID.[Id] IS NOT NULL
				AND ID.[EndDate] BETWEEN ''' + @StartDate + ''' AND  ''' + @EndDate + '''
				AND ID.[AttentionTime] BETWEEN ' + (SELECT CONVERT(varchar(10), @MinDuration)) + ' AND ' + (SELECT CONVERT(varchar(10), @MaxDuration)) + ' '

	IF (@Campaigns IS NOT NULL AND @Campaigns != '') SET @SQL_FILTER += 'AND ID.[IdCampaign] IN (SELECT Value FROM [dbo].[split](''' + @Campaigns + ''','','')) '
	IF (@Agents IS NOT NULL AND @Agents != '') SET @SQL_FILTER += 'AND IAD.[Actor] IN (SELECT Value FROM [dbo].[split](''' + @Agents + ''','','')) '
	IF (@Origins IS NOT NULL AND @Origins != '') SET @SQL_FILTER += 'AND ID.[Direction] IN (SELECT Value FROM [dbo].[split](''' + @Origins + ''','','')) '
	IF (@Results IS NOT NULL AND @Results != '') SET @SQL_FILTER += 'AND ID.[ManagementResult] IN (SELECT Value FROM [dbo].[split](''' + @Results + ''','','')) ';
	IF (@Formats IS NOT NULL AND @Formats != '') SET @SQL_FILTER += 'AND IMP.[InteractionFormat] IN (SELECT Value FROM [dbo].[split](''' + @Formats + ''','','')) ';

	-- PARA EL CASO EN QUE HORA DE INICIO Y FIN NO SEAN NULL
	IF @StartHour IS NOT NULL AND @EndHour IS NOT NULL
	BEGIN
		IF (CAST(@StartHour AS TIME) <= CAST(@EndHour AS TIME)) 
			SET @SQL_FILTER += 'AND CAST(ID.[EndDate] AS TIME) BETWEEN ''' + @StartHour + ''' AND ''' + @EndHour + ''' '
		IF (CAST(@StartHour AS TIME) > CAST(@EndHour AS TIME)) 
			SET @SQL_FILTER += 'AND CAST(ID.[EndDate] AS TIME) NOT BETWEEN ''' + @EndHour + ''' AND ''' + @StartHour + ''' '
	END
	-- PARA EL CASO EN QUE HORA DE INICIO NO SEA NULL Y FIN SEA NULL
	ELSE IF @StartHour IS NOT NULL AND @EndHour IS NULL
	BEGIN
		SET @SQL_FILTER += 'AND CAST(ID.[EndDate] AS TIME) > ''' + @StartHour + ''' '
	END
	-- PARA EL CASO EN QUE HORA DE INICIO SEA NULL Y FIN NO SEA NULL
	ELSE IF @StartHour IS NULL AND @EndHour IS NOT NULL
	BEGIN
		SET @SQL_FILTER += 'AND CAST(ID.[EndDate] AS TIME) < ''' + @EndHour + ''' '
	END
	
	-- UNIMOS LAS PARTES DEL QUERY
	SET @SQL_SELECT_1 += @SQL_FROM + @SQL_FILTER + @SQL_EXTRA;

	-- EJECUTAMOS LA CONSULTA
	EXEC (@SQL_SELECT_1);
	
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
