SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetCosts] (
	@InstallationId VARCHAR(100)=NULL,
	@AccountId VARCHAR(50) = NULL,
	@SubAccountId VARCHAR(50) = NULL,
	@VCC VARCHAR(50) = NULL
	)
AS
BEGIN
	-- ESTE PROCEDURE TIENE POR FINALIDAD RETORNAR LOS GSATOS POR FECHAS PARA LAS GRAFICAS
	SET NOCOUNT ON

	BEGIN TRY

		-- LANZAMOS MENSAJE DE ERROR SI EL INSTALLATIONID LLEGA NULO
		IF @InstallationId IS NULL
			RAISERROR('DATABASE_ERROR_MISSING_PARAMETERS', 16, 16)

		-- EN CASO EL VCC SEA SYSTEM, LO IGUALAMOS A NULL PARA QUE TOME TODOS LOS VALORES
		IF @VCC = 'system' SET @VCC = NULL

		SELECT 
			AVB.[SystemService]				'name',
			AVB.[CountableBalance]			'amount',
			AVB.[AvailableBalance]			'available',
			AVB.[RetainedBalance]			'retained',
			C.[Code]						'currencyCode',
			C.[Symbol]						'currencySymbol'
		FROM AccountVCCBalance AVB (NOLOCK)
		INNER JOIN [dbo].[Account] A (NOLOCK)
			ON A.[InstallationId] = AVB.[InstallationId]
				AND A.[AccountId] = AVB.[AccountId]
				AND (
					A.[SubAccountId] = AVB.[SubAccountId]
					OR (
						A.[SubAccountId] IS NULL
						AND 
						AVB.[SubAccountId] IS NULL
					)
				)
		INNER JOIN [dbo].[Currency] C (NOLOCK)
			ON C.[Code] = A.[CurrencyCode]
		WHERE AVB.[InstallationId] IS NOT NULL
			AND   (@InstallationId IS NULL OR AVB.[InstallationId] = @InstallationId)
			AND   (@VCC IS NULL OR AVB.[VCC] = @VCC)
			AND   (@AccountId IS NULL OR AVB.[AccountId] = @AccountId)
			AND   (@SubAccountId IS NULL OR AVB.[SubAccountId] = @SubAccountId)

	END TRY
    BEGIN CATCH
        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
		DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1;
    END CATCH;

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
