SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[GetInstallationIds]
(@InstallationId VARCHAR(100) = NULL)
AS
BEGIN
	SET NOCOUNT ON

	/*
	SELECT DISTINCT A.[InstallationId]				'installationId',
		A.[AccountId]								'accountId',
		A.[SubAccountId]							'subAccountId',
		AV.[VCC]									'vcc',
		UA.[UserApi]								'apiUser'
	FROM [dbo].[Account] A (NOLOCK)
	LEFT JOIN [dbo].[AccountVCC] AV (NOLOCK)
		ON AV.[InstallationId] = A.[InstallationId] 
			AND AV.[AccountId] = A.[AccountId]
			AND AV.[SubAccountId] = CASE WHEN A.[SubAccountId] IS NOT NULL THEN A.[SubAccountId] ELSE AV.[SubAccountId] END
	LEFT JOIN [UserApi] UA (NOLOCK)
		ON UA.[InstallationId] = A.[InstallationId]
			AND UA.[VCC] = AV.[VCC]
	WHERE A.[InstallationId] IS NOT NULL
		AND   (@InstallationId IS NULL OR A.[InstallationId] = @InstallationId)
	ORDER BY A.[AccountId] ASC
	*/
	
	SELECT
		DISTINCT P.[InstallationId]				'installationId',
		PD.[Name]								'name',
		AV.[VCC]								'vcc',
		U.[UserApi]								'apiUser',
		AV.[AccountId]							'accountId',
		A.[SubAccountId]						'subAccountId'
	FROM [dbo].[Platform] P (NOLOCK)
	INNER JOIN [dbo].[PlatformData] PD (NOLOCK)
		ON PD.[PlatformHash] = P.[PlatformHash]
			AND PD.[InstallationId] = P.[InstallationId]
	LEFT JOIN [dbo].[Account] A (NOLOCK) 
		ON A.[InstallationId] = P.[InstallationId]
	LEFT JOIN  [dbo].[AccountVCC] AV (NOLOCK)
		ON AV.[InstallationId] = P.[InstallationId]
			AND AV.[AccountId] = A.[AccountId]
			AND ((AV.[SubAccountId] IS NULL AND A.[SubAccountId] IS NULL) OR (AV.[SubAccountId] = A.[SubAccountId]))
	LEFT JOIN [dbo].[UserApi] U  (NOLOCK)
		ON A.[InstallationId] = U.[InstallationId]
		AND U.[VCC] = AV.[VCC]
	WHERE P.[InstallationId] IS NOT NULL
		AND (@InstallationId IS NULL OR P.[InstallationId] = @InstallationId)

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
