SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetMovementCurrencies] (
	@InstallationId VARCHAR(100) = NULL,
	@StartDate DATETIME = NULL,
	@EndDate DATETIME = NULL,
	@AccountId VARCHAR(50) = NULL,
	@SubAccountId VARCHAR(50) = NULL,
	@VCC VARCHAR(50) = NULL
) AS
BEGIN
	-- ESTE PROCEDURE TIENE POR FINALIDAD RETORNAR LAS MONEDAS USADAS EN MOVIMIENTOS OCURRIDOS EN UN RANGO DE TIEMPO
	SET NOCOUNT ON

	-- EN CASO EL VCC SEA SYSTEM, LO IGUALAMOS A NULL PARA QUE TOME TODOS LOS VALORES
	IF @VCC = 'system' SET @VCC = NULL

	SELECT C.[LargeName]					'largeName',
			C.[ShortName]					'shortName',
			C.[Code]						'code',
			C.[Symbol]						'symbol',
			C.[IsInternational]				'isInternational'
		FROM [dbo].[AccountSubAccountVCCBalanceMovement] ASAVBM (NOLOCK)
		INNER JOIN [dbo].[Currency] C (NOLOCK)
			ON C.[Code] = ASAVBM.[CurrencyCode]
		/*
		WHERE ASAVBM.[AccountId] = 'rgpedro'
			AND ASAVBM.[SubAccountId] IS NULL
			AND ASAVBM.[VCC] = 'allegro'
			AND ASAVBM.[CreatedDate] > '2021-01-01'
		
		*/
		WHERE ASAVBM.[InstallationId] IS NOT NULL
			AND (
				@InstallationId IS NULL
				OR 
				ASAVBM.[InstallationId] = @InstallationId
			)
			AND (
				@StartDate IS NULL 
				OR 
				ASAVBM.[TimeStamp] >= @StartDate
			)
			AND (
				@EndDate IS NULL 
				OR 
				ASAVBM.[TimeStamp] <= @EndDate
			)
			AND (
				@AccountId IS NULL 
				OR 
				ASAVBM.[AccountId] = @AccountId
			)
			AND (
				@SubAccountId IS NULL 
				OR 
				ASAVBM.[SubAccountId] = @SubAccountId
			)
			AND (
				@VCC IS NULL 
				OR 
				ASAVBM.[VCC] = @VCC
			)
		GROUP BY C.[LargeName],
					C.[ShortName],
					C.[Code],
					C.[Symbol],
					C.[IsInternational]	

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
