SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetMovements] (
	@InstallationId VARCHAR(100)=NULL,
	@StartDate DATETIME = NULL,
	@EndDate DATETIME = NULL,
	@AccountId VARCHAR(50) = NULL,
	@SubAccountId VARCHAR(50) = NULL,
	@VCC VARCHAR(50) = NULL,
	@Currencies VARCHAR(250) = NULL
	)
AS
BEGIN
	-- ESTE PROCEDURE TIENE POR FINALIDAD RETORNAR LOS GSATOS POR FECHAS PARA LAS GRAFICAS
	SET NOCOUNT ON

	-- EN CASO EL VCC SEA SYSTEM, LO IGUALAMOS A NULL PARA QUE TOME TODOS LOS VALORES
	IF @VCC = 'system' SET @VCC = NULL

	SELECT 
			FORMAT(ST.[EndDate], 'yyyy-MM-dd HH:00:00')			'date',
			--ST.[Rate]											'amount',
			C.[Code]											'currencyCode',
			C.[Symbol]											'currencySymbol',
			SUM(ST.[Rate])										'amount',
			ST.[SystemService]									'service'
		FROM AccountSubAccountVCCSummaryTransaction ST (NOLOCK)
		LEFT JOIN AccountVCC A (NOLOCK)
			ON A.[InstallationId] = ST.InstallationId
			AND A.[VCC] = ST.[VCC] 
		INNER JOIN [dbo].[Currency] C (NOLOCK) 
			ON C.[Code] = ST.[CurrencyCode]
		WHERE ST.[InstallationId]	IS NOT NULL
			AND   (@InstallationId is null OR ST.[InstallationId] = @InstallationId)
			AND   (@VCC IS NULL OR ST.[VCC] = @VCC)
			AND   (@AccountId IS NULL OR A.[AccountId] = @AccountId)
			AND   (@SubAccountId IS NULL OR A.[SubAccountId] = @SubAccountId)
			--  AND   (@StartDate IS NULL OR FORMAT(ST.[EndDate], 'yyyy-MM-dd')	 >= FORMAT(@StartDate, 'yyyy-MM-dd'))
			-- AND   (@EndDate IS NULL OR FORMAT(ST.[EndDate], 'yyyy-MM-dd')	 <=FORMAT(@EndDate, 'yyyy-MM-dd'))
			AND   (@StartDate IS NULL OR ST.[EndDate] >= @StartDate)
			AND   (@EndDate IS NULL OR ST.[EndDate] <= @EndDate)
			AND ST.[EndDate] IS NOT NULL
			AND (
				@Currencies IS NULL
				OR 
				@Currencies = ''
				OR
				ST.[CurrencyCode] IN (SELECT VALUE FROM [dbo].[split](@Currencies,','))
			)
		GROUP BY C.[Code], C.[Symbol], FORMAT(ST.[EndDate], 'yyyy-MM-dd HH:00:00') , ST.SystemService

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
