SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetRelatedSubAccounts] (
	@InstallationId Varchar(100) = NULL
	--@UserId Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	-- DECLARAMOS UNA VARIABLE PARA ALCENAR EL NIVEL DE LA CUENTA 
	DECLARE @ACCOUNT_LEVEL INT

	SET @ACCOUNT_LEVEL = 1

	/*
	-- RECUPERAMOS EL NIVEL DE LA CUENTA
	SELECT @ACCOUNT_LEVEL = A.[AccountLevel]
		FROM Account A (NOLOCK)
	WHERE A.[AccountId] = @AccountId
		AND [Enabled] = 1
	*/
	
	-- SI EL NIVEL DE LA CUENTA ES 1, SE REFIERE AL DUENO DE LA PLATAFORMA
	IF (@ACCOUNT_LEVEL = 1)
	BEGIN 

		-- BUSCAMOS TODAS LAS SUBCUENTAS ENABLED 1 GUARDADAS
		SELECT A.[InstallationId]				'installationId',
				A.[AccountId]					'accountId',
				A.[SubAccountId]				'subAccountId',
				A.[User]						'user',
				A.[Token]						'token',
				COUNT(AV.[VCC])					'vccs'
		FROM Account A (NOLOCK)
		LEFT JOIN dbo.[AccountVCC] AV (NOLOCK)
			ON AV.[InstallationId] = A.[InstallationId]
				AND AV.[AccountId] = A.[AccountId]
				AND (
					(AV.[SubAccountId] IS NULL AND A.[SubAccountId] IS NULL)
					OR 
					(AV.[SubAccountId] = A.[SubAccountId])
				)
		WHERE A.[InstallationId] = @InstallationId
			AND A.[SubAccountId] IS NOT NULL 
			AND A.[Enabled] = 1
		GROUP BY A.[InstallationId], A.[AccountId], A.[SubAccountId], A.[User], A.[Token] 
		ORDER BY A.[AccountId] ASC

	END
	ELSE
	BEGIN 
		
		-- BUSCAMOS TODAS LAS SUBCUENTAS RELACIONADAS A LA CUENTA 
		SELECT A.[InstallationId]				'installationId',
				A.[AccountId]					'accountId',
				A.[SubAccountId]				'subAccountId',
				A.[User]						'user',
				A.[Token]						'token',
				COUNT(AV.[VCC])					'vccs'
		FROM Account A (NOLOCK)
		LEFT JOIN dbo.[AccountVCC] AV (NOLOCK)
			ON AV.[InstallationId] = A.[InstallationId]
				AND AV.[AccountId] = A.[AccountId]
				AND (
					(AV.[SubAccountId] IS NULL AND A.[SubAccountId] IS NULL)
					OR 
					(AV.[SubAccountId] = A.[SubAccountId])
				)
		WHERE A.[InstallationId] = @InstallationId
			AND A.[Enabled] = 1
			--AND A.[AccountOwner] = @AccountId 
		GROUP BY A.[InstallationId], A.[ID], A.[AccountId], A.[SubAccountId], A.[User], A.[Token] 
		ORDER BY A.[AccountId] ASC

	END
	
	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
