SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[GetSubAccountsBalance]
(
	@AccountId				VARCHAR(50) = NULL,
	@InstallationId			VARCHAR(100) = NULL
)
AS
BEGIN
	-- ESTE SP RECUPERA TODAS LAS SUBCUENTAS CON SUS SALDOS DISPONIBLES
	SET NOCOUNT ON

	-- DECLARAMOS LAS CTE QUE JUNTARAN LA DATA REQUERIDA PARA EL RESULT
	;WITH CTE_VCCS_TOTAL_BALANCE AS (
		-- SELECCIONAMOS LA SUMA TOTAL DEL DISPONIBLE Y RETENIDO DE LOS VCCS DE LA SUBCUENTA
		SELECT INNER_AVB.[InstallationId]								'InstalationId',
				INNER_AVB.[AccountId]									'AccountId',
				INNER_AVB.[SubAccountId]								'SubAccountId',
				SUM(INNER_AVB.[AvailableBalance])						'VCCsTotalAvailableBalance', 
				SUM(INNER_AVB.[RetainedBalance])						'VCCsTotalRetainedBalance' 
			FROM [dbo].[AccountVCCBalance] INNER_AVB (NOLOCK) 
			WHERE INNER_AVB.[InstallationId] = @InstallationId 
				AND INNER_AVB.[AccountId] = CASE WHEN @AccountId IS NULL THEN INNER_AVB.[AccountId] ELSE @AccountId END
			GROUP BY INNER_AVB.[InstallationId], INNER_AVB.[AccountId], INNER_AVB.[SubAccountId]
	)

	SELECT AB.[PlatformHash]											'platformHash',
			AB.[ID]														'id',
			AB.[InstallationId]											'installationId',
			AB.[AccountId]												'accountId',
			AB.[SubAccountId]											'subAccountId',
			AB.[TotalBalance]											'totalBalance',
			AB.[AvailableBalance]										'availableBalance',
			AB.[AssignedBalance]										'assignedBalance',
			AB.[IsLocked]												'isLocked',
			CTE_VTB.[vccsTotalAvailableBalance]							'vccsTotalAvailableBalance', 
			CTE_VTB.[vccsTotalRetainedBalance]							'vccsTotalRetainedBalance' 
		FROM [dbo].[AccountBalance] AB (NOLOCK)
		LEFT JOIN CTE_VCCS_TOTAL_BALANCE CTE_VTB 
			ON CTE_VTB.[InstalationId] = AB.[InstallationId]
				AND CTE_VTB.[AccountId] = AB.[AccountId]
				AND CTE_VTB.[SubAccountId] = AB.[SubAccountId]
		WHERE AB.[InstallationId] = @InstallationId 
			AND AB.[AccountId] = @AccountId  
			AND AB.[SubAccountId] IS NOT NULL

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
