SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetVCCsByAccount]
(
	@InstallationId				VARCHAR(100),
	@AccountId					VARCHAR(100),
	@Type						VARCHAR(20)
)
AS
BEGIN
	-- ESTE PROCEDIMIENTO ALMACENADO SE ENCARGA DE OBTENER LOS VCC DE UN ACCOUNTID O DE UN SUBACCOUNTID.
	-- EL PARAMETRO TYPE ES PARA CONDICIONAR CON LA COLUMNA.
	-- @AccountId PUEDE SER UN ACCOUNTID O UN SUBACCOUNTID SELECCIONADO.
	SET NOCOUNT ON

	-- EVALUAMOS DE ACUERDO AL PARAMETRO TYPE, SI ES DESDE UNA CUENTA O SUBCUENTA.
	-- SI TPYE ES NONE, CONSULTAMOS POR AQUELLAS CUENTAS CUYO SUBACCOUNTID IS NULL.
	IF(@Type = 'accountId')

	BEGIN
		SELECT
			AV.[InstallationId]				'installationId',
			AV.[AccountId]						'accountId',
			AV.[SubAccountId]					'subAccountId',
			AV.[VCC]							'vcc'
		FROM [dbo].[AccountVCC] AV (NOLOCK)
		INNER JOIN [dbo].[Account] A (NOLOCK)
			ON A.[InstallationId] = AV.[InstallationId]
				AND A.[AccountId] = AV.[AccountId]
				AND A.[SubAccountId] = AV.[SubAccountId]
		WHERE AV.[InstallationId] = @InstallationId
			AND AV.[AccountId] = @AccountId
			AND AV.[SubAccountId] IS NOT NULL
			AND A.[Enabled] = 1
	END
	ELSE IF(@Type = 'subAccountId')
	BEGIN
		SELECT AV.[InstallationId]				'installationId',
				AV.[AccountId]						'accountId',
				AV.[SubAccountId]					'subAccountId',
				AV.[VCC]							'vcc'
		FROM [dbo].[AccountVCC] AV (NOLOCK)
		INNER JOIN [dbo].[Account] A (NOLOCK)
			ON A.[InstallationId] = AV.[InstallationId]
				AND A.[SubAccountId] = AV.[SubAccountId]
		WHERE AV.[InstallationId] = @InstallationId
			AND AV.[SubAccountId] = @AccountId
			AND A.[Enabled] = 1
	END
	ELSE

	-- EN CASO SE SELECCIONE SIN VCC.
	BEGIN
		SELECT AV.[InstallationId]				'installationId',
				AV.[AccountId]						'accountId',
				AV.[SubAccountId]					'subAccountId',
				AV.[VCC]							'vcc'
		FROM [dbo].[AccountVCC] AV (NOLOCK)
		INNER JOIN [dbo].[Account] A (NOLOCK)
			ON A.[InstallationId] = AV.[InstallationId]
				AND A.[AccountId] = AV.[AccountId]
				AND A.[SubAccountId] IS NULL
		WHERE AV.[InstallationId] = @InstallationId
			AND AV.[AccountId] = @AccountId
			AND AV.[SubAccountId] IS NULL
			AND A.[Enabled] = 1
	END
	
	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
