SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[ReportByVCCBalanceSummary] (
	@PlatformHash VARCHAR(100)=NULL,
	@StartDate DATETIME = NULL,
	@EndDate DATETIME = NULL,
	@InstallationId VARCHAR(100)=NULL,
	@AccountId VARCHAR(50) = NULL,
	@SubAccountId VARCHAR(50) = NULL,
	@VCC VARCHAR(50) = NULL,
	@UserApi VARCHAR(50) = NULL,
	@BatchTypeName VARCHAR(50) = NULL,
	@BatchTypeId VARCHAR(50) = NULL
	
	)
AS
BEGIN
	-- ESTE PROCEDURE TIENE POR FINALIDAD RETORNAR EL SALDO COUNTABLE, DISPONIBLE Y RETENIDO FINAL
	SET NOCOUNT ON
	DECLARE
	@TotalSpending DECIMAL(18,5)


	SELECT
		AST.[StartDate]													'startDate',
		AST.[EndDate]												'endDate',
		AST.[BatchTypeName]												'batchTypeName',
		AST.[BatchTypeId]												'batchTypeId',
		AST.[UserApi]													'userApi',
		AST.[Rate]														'rate'
	FROM [AccountSubAccountVCCSummaryTransaction] AST (NOLOCK)
	LEFT JOIN [AccountSubAccountVCCDetailedTransaction] ADT (NOLOCK)
		ON ADT.[BatchId] = AST.[BatchID]
	WHERE AST.[InstallationId] IS NOT NULL
		AND   (@InstallationId IS NULL OR AST.[InstallationId] = @InstallationId)
		AND   (@VCC IS NULL OR AST.[VCC] = @VCC)
		AND   (@StartDate IS NULL OR AST.[EndDate] >= @StartDate)
		AND   (@EndDate IS NULL OR AST.[EndDate] <= @EndDate)
		AND   (@BatchTypeName IS NULL OR AST.[BatchTypeName] = @BatchTypeName)
		AND   (@BatchTypeId IS NULL OR AST.[BatchTypeId] = @BatchTypeId)
		AND   (@UserApi IS NULL OR AST.[UserApi] = @UserApi)
		AND   (@AccountId IS NULL OR ADT.[AccountId] = @AccountId)
		AND   (@SubAccountId IS NULL OR ADT.[SubAccountId] = @SubAccountId)
	GROUP BY AST.[StartDate], AST.[EndDate], AST.[BatchTypeName], AST.[BatchTypeId], AST.[UserApi], AST.[Rate]


	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
