SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE Procedure [dbo].[ReportSummaryofExpensesbyPeriod] (
	@StartDate DATETIME = NULL,
	@EndDate DATETIME = NULL,
	@InstallationId Varchar(150),
	@AccountId Varchar(150)  = NULL,
	@SubAccountId Varchar(150)  = NULL,
	@VCC Varchar(150)  = NULL,
	@Slice Int = 1
) As
BEGIN 
	-- EN CASO EL VALOR DE VCC LEGUE COMO SYSTEM LO IGUALAMOS A NULL
	IF @VCC = 'system' SET @VCC = NULL

	SELECT 
	  case @Slice
		when 1 then Dateadd(DAY,datediff(DAY, 0, A.enddate), 0)
		when 30 then Dateadd(MONTH,datediff(MONTH, 0, A.enddate), 0)
		else Dateadd(DAY,datediff(DAY, 0, A.enddate), 0)
	  end																											AS 'COLUMN_SLICE',
	  --Dateadd(day, 0, @Slice * Floor(Datediff(day, 0, A.enddate) / @Slice)) AS SLICE, 
	  A.systemservice																								AS 'COLUMN_BATCH_TYPE_NAME', 
	  Avg(A.TranscriptionRatePerSecond)																				AS 'COLUMN_TRANSCRIPTION_RATE_PER_SECOND', 
	  avg(A.SemanticAnalysisRatePerTransaction)																		AS 'COLUMN_SEMANTIC_ANALYSIS_RATE_PER_TRANSACTION', 
	  avg(A.CognitiveAnalysisRatePerTransaction)																	AS 'COLUMN_COGNITIVE_ANALYSIS_RATE_PER_TRANSACTION', 
	  A.installationid																								AS 'COLUMN_PLATFORM', 
	  B.accountid																									AS 'COLUMN_ACCOUNT', 
	  B.subaccountid																								AS 'COLUMN_SUBACCOUNT', 
	  C.[Code]																										AS 'COLUMN_CURRENCY_CODE',
	  -- C.[Symbol]																									AS 'COLUMN_CURRENCY_SYMBOL',
	  A.vcc																											AS 'COLUMN_VCC', 
	  Sum(CASE WHEN A.[SystemService] = 'TRANSCRIPTION' THEN ISNULL(A.[ValidDurationTime], 0) ELSE 0 END)			AS 'COLUMN_TRANSCRIPTION_VALID_DURATION_TIME', 
	  -- Sum(A.Totalqueries) AS CANTIDADAS, 
	  Sum(A.TotalQueryRequest)																						AS 'COLUMN_SEMANTIC_ANALYSIS_TOTAL_REQUEST', 
	  Sum(A.totalmodelrequest)																						AS 'COLUMN_COGNITIVE_ANALYSIS_TOTAL_REQUEST', 
	  --Sum(A.Rate) As Rate, 
	  SUM(CASE WHEN A.[SystemService] = 'TRANSCRIPTION' THEN ISNULL(A.[Rate], 0) ELSE 0 END)						AS 'COLUMN_TRANSCRIPTION_TOTAL_RATE', 
	  SUM(CASE WHEN A.[SystemService] = 'SEMANTIC_ANALYSIS' THEN ISNULL(A.[Rate], 0) ELSE 0 END)					AS 'COLUMN_SEMANTIC_ANALYSIS_TOTAL_RATE', 
	  SUM(CASE WHEN A.[SystemService] = 'COGNITIVE_ANALYSIS' THEN ISNULL(A.[Rate], 0) ELSE 0 END)					AS 'COLUMN_COGNITIVE_ANALYSIS_TOTAL_RATE' 
	  /*
	  Sum(A.transcriptionratepersecond) * Sum(CASE WHEN A.[SystemService] = 'TRANSCRIPTION' THEN ISNULL(A.[ValidDurationTime], 0) ELSE 0 END) AS TOTALTR, 
	  Sum(A.semanticanalysisratepertransaction) * Sum(A.validtotalqueries) AS TOTALAS, 
	  Sum(A.cognitiveanalysisratepertransaction) * Sum(A.totalmodelrequest) AS TOTALAC */
	FROM accountsubaccountvccsummarytransaction (nolock) AS A 
	LEFT JOIN accountvcc (nolock) AS B 
		ON A.installationid = B.installationid 
			AND A.vcc = B.vcc 
	INNER JOIN [dbo].[Currency] C (NOLOCK)
		ON C.[Code] = A.[CurrencyCode]
	WHERE A.installationid = @InstallationId 
		AND A.enddate BETWEEN @StartDate 
		AND @EndDate 
		AND B.accountid LIKE CASE WHEN @AccountId IS NOT NULL THEN @AccountId ELSE B.accountid END 
		AND   (
			((@SubAccountId IS NULL OR @SubAccountId = 'NONE') AND B.[SubAccountId] IS NULL)
			OR (@SubAccountId = 'ALL_SUBACCOUNTS' AND B.[SubAccountId] IS NOT NULL)
			OR B.[SubAccountId] = @SubAccountId
		)
		AND   (
			(@VCC IS NOT NULL AND A.[VCC] = @VCC)
			OR A.[VCC] IS NOT NULL
		)
		--AND A.vcc LIKE CASE WHEN @VCC IS NOT NULL THEN @VCC ELSE A.vcc END -- 
	GROUP BY 
	  case @Slice
		when 1 then Dateadd(DAY,datediff(DAY, 0, A.enddate), 0)
		when 30 then Dateadd(MONTH,datediff(MONTH, 0, A.enddate), 0)
		else Dateadd(DAY,datediff(DAY, 0, A.enddate), 0)
	  end,
	  --Dateadd(DAY,datediff(DAY, 0, A.enddate), 0),
	  --Dateadd(day, 0, @Slice * Floor(Datediff(day, 0, A.enddate) / @Slice)), 
	  A.vcc, 
	  A.systemservice, 
	  B.accountid, 
	  B.subaccountid, 
	  C.[Code],
	  -- C.[Symbol],
	  A.installationid

END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
