SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[SaveApiUser] (
	@InstallationId VARCHAR(100) = NULL,
	@VCC VARCHAR(50) = NULL,
	@Pin VARCHAR(250),
	@UserApi VARCHAR(50) = NULL,
	@FailedTry INT = NULL,
	@IsLocked BIT = NULL,
	@CreatedDate DATETIME = NULL,
	@CreatedByUserId VARCHAR(50) = NULL,
	@CreatedByRemoteUser BIT = NULL,
	@LastModifiedDate DATETIME = NULL,
	@LastModifiedByUserId VARCHAR(50) = NULL,
	@LastModifiedByRemoteUser BIT = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	UPDATE [dbo].[UserApi] 
		SET [Pin] = @Pin,
			[LastModifiedDate]=GETUTCDATE(),
			[LastModifiedByUserId]=@LastModifiedByUserId,
			[TimeStamp] = GETUTCDATE()
	WHERE
		[UserApi] = @UserApi AND [VCC] = @VCC

	
	IF @@ROWCOUNT = 0
	BEGIN
		INSERT INTO [dbo].[UserApi](
			[InstallationId],
			[VCC],
			[UserApi],
			[Pin],
			[FailedTry],
			[IsLocked],
			[CreatedDate],
			[CreatedByUserId],
			[CreatedByRemoteUser],
			[LastModifiedDate],
			[LastModifiedByUserId],
			[LastModifiedByRemoteUser],
			[TimeStamp]
		)
		VALUES(
			@InstallationId,
			@VCC,
			@UserApi,
			@Pin,
			@FailedTry,
			@IsLocked,
			@CreatedDate,
			@CreatedByUserId,
			@CreatedByRemoteUser,
			@LastModifiedDate,
			@LastModifiedByUserId,
			@LastModifiedByRemoteUser,
			GETUTCDATE()
		)
	END
	

	SELECT 1 AS 'result'
	

	SET NOCOUNT OFF
END 
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
