SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[SaveClient] (
	@ClientName VARCHAR(100) = NULL
) AS
BEGIN
	SET XACT_ABORT, NOCOUNT ON

	-- VERIFICAMOS SI EXISTE UN CLIENTE CON EL NOMBRE INGRESADO
	IF NOT EXISTS (
		SELECT 1 
			FROM [dbo].[Client] C (NOLOCK)
			WHERE C.[ClientName] = @ClientName
	) 
	BEGIN
		-- SI EL NOMBRE NO EXSISTE EN LA BD, LO INSERTAMOS
		INSERT INTO [dbo].[Client] ([ClientId], [ClientName], [CreatedDate], [TimeStamp])
			VALUES (NEWID(), @ClientName, GETUTCDATE(), GETUTCDATE())
	END

	SET XACT_ABORT, NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
