SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[UpdatePlatformHash] (
	@PlatformHash VARCHAR(100) = NULL,
	@PlatformHashNew VARCHAR(100) = NULL,
	@User VARCHAR(50) = NULL
	)
AS
BEGIN
	-- ESTE SP TIENE LA FINALIDAD DE ACTUALIZAR LOS PLATFORMHASH
	SET XACT_ABORT, NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY

		-- INICIAMOS LA TRANSACCION
		BEGIN TRANSACTION

			--Actualizamos en la  tabla Account
			UPDATE [Account]
			SET [PlatformHash]=@PlatformHashNew
			WHERE [PlatformHash]=@PlatformHash

			--Actualizamos Account Balance
			UPDATE[AccountBalance]
			SET [PlatformHash]=@PlatformHashNew
			WHERE [PlatformHash]=@PlatformHash

			--Actualizamo AccounSubAccountVCCDetailedBalance
			UPDATE[AccountSubAccountVCCDetailedBalance]
			SET [PlatformHash]=@PlatformHashNew
			WHERE [PlatformHash]=@PlatformHash

			--Actualizamos AccountSubAccountVCCGeneralBalance
			UPDATE[AccountSubAccountVCCGeneralBalance]
			SET [PlatformHash]=@PlatformHashNew
			WHERE [PlatformHash]=@PlatformHash

			--Actualizamos Platform
			UPDATE[Platform]
			SET [PlatformHash]=@PlatformHashNew
			WHERE [PlatformHash]=@PlatformHash

			--ActualizamosPlatformData
			UPDATE[PlatformData]
			SET [PlatformHash]=@PlatformHashNew
			WHERE [PlatformHash]=@PlatformHash

			--Actualizamos PlatformLicense
			UPDATE[PlatformLicense]
			SET [PlatformHash]=@PlatformHashNew
			WHERE [PlatformHash]=@PlatformHash


			SELECT 1 AS 'result'
		-- COMPLETAMOS LA TRANSACCION
		COMMIT TRANSACTION
	END TRY

    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
