CREATE TABLE [dbo].[AccountSubAccountVCCBalanceMovement] (
   [ID] [varchar](100) NOT NULL 
      CONSTRAINT [DF_AccountSubAccounVCCBalanceMovement_ID] DEFAULT (newid()),
   [InstallationId] [varchar](50) NULL ,
   [AccountId] [varchar](50) NOT NULL ,
   [SubAccountId] [varchar](50) NULL ,
   [VCC] [varchar](50) NULL ,
   [Wallet] [varchar](50) NOT NULL ,
   [Type] [varchar](50) NULL ,
   [CurrentStep] [int] NOT NULL   ,
   [TotalSteps] [int] NOT NULL   ,
   [Description] [nvarchar](250) NULL ,
   [BatchId] [varchar](100) NULL ,
   [CurrencyCode] [varchar](5) NULL ,
   [Amount] [decimal](18,5) NOT NULL  ,
   [PrevAvailableBalance] [decimal](18,5) NULL 
      CONSTRAINT [DF_AccountSubAccountVCCBalanceMovement_PrevAvailableBalance] DEFAULT ((0)) ,
   [PostAvailableBalance] [decimal](18,5) NULL 
      CONSTRAINT [DF_AccountSubAccountVCCBalanceMovement_PostAvailableBalance] DEFAULT ((0)) ,
   [PrevCountableBalance] [decimal](18,5) NULL 
      CONSTRAINT [DF_AccountSubAccountVCCBalanceMovement_PrevCountableBalance] DEFAULT ((0)) ,
   [PostCountableBalance] [decimal](18,5) NULL 
      CONSTRAINT [DF_AccountSubAccountVCCBalanceMovement_PostCountableBalance] DEFAULT ((0)) ,
   [CreatedDate] [datetime] NULL   ,
   [CreatedByUserId] [varchar](50) NULL ,
   [LastModifiedDate] [datetime] NULL   ,
   [LastModifiedByUserId] [varchar](50) NULL ,
   [TimeStamp] [datetime] NULL 
      CONSTRAINT [DF_AccountSubAccounVCCBalanceMovement_TimeStamp] DEFAULT (getutcdate())  ,
   [Date] [date] NULL 
      CONSTRAINT [DF_AccountSubAccounVCCBalanceMovement_Date] DEFAULT (CONVERT([date],getutcdate()))  ,
   [Time] [time] NULL 
      CONSTRAINT [DF_AccountSubAccounVCCBalanceMovement_Time] DEFAULT (CONVERT([time],getutcdate()))  

   ,CONSTRAINT [PK_AccountSubAccountVCCBalanceMovement] PRIMARY KEY CLUSTERED ([ID], [CurrentStep])
)

CREATE  NONCLUSTERED INDEX [IX_AccountSubAccountVCCBalanceMovement_InstallationId_AccountId_VCC_Wallet_Type] ON [dbo].[AccountSubAccountVCCBalanceMovement] ([InstallationId], [AccountId], [VCC], [Wallet], [Type]) INCLUDE ([SubAccountId], [BatchId], [Amount])

GO
