CREATE TABLE [dbo].[AccountSubAccountVCCDetailedTransaction] (
   [ID] [varchar](100) NOT NULL 
      CONSTRAINT [DF_AccountSubAccountVCCDetailedTransaction_ID] DEFAULT (newid()),
   [InstallationId] [varchar](50) NOT NULL ,
   [ClientId] [varchar](50) NULL ,
   [BatchId] [varchar](50) NOT NULL ,
   [BatchTypeName] [varchar](50) NULL ,
   [BatchTypeId] [varchar](50) NULL ,
   [AccountId] [varchar](50) NOT NULL ,
   [SubAccountId] [varchar](50) NULL ,
   [VCC] [varchar](50) NOT NULL ,
   [ApiId] [varchar](150) NULL ,
   [IsDemo] [bit] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCDetailedTransaction_IsDemo] DEFAULT ((0))  ,
   [SystemService] [varchar](50) NOT NULL ,
   [RatePerSecond] [decimal](18,5) NULL 
      CONSTRAINT [DF_AccountSubAccountVCCDetailedTransaction_RatePerSecond] DEFAULT ((0)) ,
   [Rate] AS ([dbo].[BatchDetailedTransactionRateCalculate]([SystemService],[RatePerSecond],[ValidDurationTime],[RatePerTransaction],[TotalRequest],[IsValid],[Description],[IsDemo])),
   [RatePerTransaction] [decimal](18,5) NULL 
      CONSTRAINT [DF_AccountSubAccountVCCDetailedTransaction_RatePerTransaction] DEFAULT ((0)) ,
   [TotalRequest] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCDetailedTransaction_TotalRequest] DEFAULT ((0))  ,
   [TotalValidRequest] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCDetailedTransaction_TotalValidRequest] DEFAULT ((0))  ,
   [TotalInvalidRequest] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCDetailedTransaction_TotalInvalidRequest] DEFAULT ((0))  ,
   [TotalPages] [int] NULL   ,
   [TotalItems] [int] NULL   ,
   [ItemsPerPage] [int] NULL   ,
   [Channel] [varchar](50) NULL ,
   [DurationTime] [int] NULL   ,
   [ValidDurationTime] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCDetailedTransaction_SecondsBilling] DEFAULT ((0))  ,
   [RawChar] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCDetailedTransaction_RawChar] DEFAULT ((0))  ,
   [ValidChar] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCDetailedTransaction_ValidChar] DEFAULT ((0))  ,
   [TotalPhrases] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCDetailedTransaction_TotalPhrases] DEFAULT ((0))  ,
   [CharsPerPhrase] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCDetailedTransaction_CharsPerPhrase] DEFAULT ((0))  ,
   [EntityId] [varchar](500) NULL ,
   [StartDate] [datetime] NULL   ,
   [EndDate] [datetime] NULL   ,
   [IsValid] [bit] NULL   ,
   [IsFinished] [bit] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCDetailedTransaction_IsFinished] DEFAULT ((0))  ,
   [Description] [varchar](50) NULL ,
   [CreatedDate] [datetime] NOT NULL 
      CONSTRAINT [DF_AccountSubAccountVCCDetailedTransaction_CreatedDate] DEFAULT (getutcdate())  ,
   [CreatedByuserId] [varchar](50) NULL ,
   [CreatedByRemoteUser] [bit] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCDetailedTransaction_CreatedByRemoteUser] DEFAULT ((1))  ,
   [LastModifiedDate] [datetime] NULL   ,
   [LastModifiedByUserId] [varchar](50) NULL ,
   [LastModifiedByRemoteUser] [bit] NULL   ,
   [TimeStamp] [datetime] NOT NULL   

   ,CONSTRAINT [PK_AccountSubAccountVCCDetailedTransaction] PRIMARY KEY CLUSTERED ([ID])
)

CREATE  NONCLUSTERED INDEX [IX_AccountSubAccountVCCDetailedTransaction_InstallationId_BatchId_VCC_SystemService] ON [dbo].[AccountSubAccountVCCDetailedTransaction] ([InstallationId], [BatchId], [VCC], [SystemService])

GO
